	implicit none
*********************************************************************
*	twert gibt die zustzliche Zeitspanne wieder, um bei ballistischer
*	Ausbreitung des Lichtes eine Distanz zu erreichen. Diese Zeitspanne
*	wird von mehreren Faktoren beeinflut. Einige Einflsse sind zu
*	vernachlssigen. Z.B. alle Parameter des Empfngers, da seine
*	Bewegung nur sehr kurz auf die viel grere Lichtgeschwindigkeit
*	trifft. Aber auch weniger deutliche Einflsse der Quelle beachten
*	wir nicht, z.B. der Einfu der Rotation der Quelle. Im vorliegenden
*	Programm wird abgeschtzt, ob evtl. auf die Emissionsrichtung
*	geachtet werden mu. Dazu betrachten wir die Differenz der twerte
*	bei Zenitemission (v) bzw. Horizontemissio (w). Bei ballistischer
*	Ausbreitung des Lichtes liegt der Startpunkt eines Photons allerdings
*	leicht hinter dem Horizont, da das Photon sich auf einer Hyperbel
*	bewegt. Es wird der relative Fehler gegenber einer Zeitabweichung
*	zur Lichtgeschwindigkeit ber einem Radienintervall bei unvernderlicher
*	Masse (Sonnenmasse) berechnet. In einem groen Bereich liegt der
*	relative Fehler unter .1%. Die damit gegebene Genauigkeit liegt daher
*	weit unter sonstigen Berechnungseinflssen, d.h. kein Bedarf an
*	Korrekturen.
*********************************************************************
	character*1 inkey,cull
	character*80 zeile
	integer dummy,getlkr
	logical logi,initgrph
	real xu,yu,xo,yo,fx,fy,x1,y1,x2,y2
	real*8 ra,re,r,twert,v,w,fak
	data fak/1.01d0/,logi/.true./
	write(*,*) ' Sonnenmasse rmin=3000 rwz=3E7 rsonn=7E8 rmax=9E9'
	write(*,'('' rmin, rmax = '',$)')
	read (*,*) ra,re
1	continue
	if(re.lt.ra) then
	 r=ra
	 ra=re
	 re=r
	end if
	if(re.eq.ra) stop ' rmin=rmax'
	r=ra
	yo=-9.e25
	yu=0.
	do while(r.lt.re)
	 v=twert(r,90.d0)
	 w=twert(r,0.d0)
	 w=(v-w)/max(v,w)
	 if(yu.gt.w) yu=w
	 if(yo.lt.w) yo=w
	 r=r*fak
	end do
	fy=425./(yo-yu)
	if(logi) then
	 if(.not.initgrph(0,0,640,425)) stop 'fenster zu gross'
	end if
	logi=.false.
	xu=dlog(ra)
	xo=dlog(re)
	fx=640./(xo-xu)
	call fenster(.false.,0.,0.,fx*(xo-xu),fy*(yo-yu))
*	call posixy()
	zeile=' '
	write(zeile,'('' ra='',f15.0,'' re='',f15.0)') ra,re
	call textaus(1,zeile(1:38)//cull())
	write(zeile,'(4f10.0)') xu,yu,xo,yo
	call textaus(2,zeile(1:40)//cull())
	write(zeile,'(4f10.0)')  0.,0.,fx*(xo-xu),fy*(yo-yu)
	call textaus(3,zeile(1:40)//cull())
	if(inkey().eq.'x') stop
***	call pltonoff()
	call farbe(14)
	if(ra.lt.3.d7.and.3.d7.lt.re)
     +	call strecke(fx*(log(3.e7)-xu),0.,fx*(log(3.e7)-xu),fy*(yo-yu))
	if(ra.lt.7.d8.and.7.d8.lt.re)
     +	call strecke(fx*(log(7.e8)-xu),0.,fx*(log(7.e8)-xu),fy*(yo-yu))
	x1=xu
	x2=xo
	y1=.00001
	do while(y1.lt.yo)
*	 call posixy()
	 write(*,'(f9.5)') y1
	 call farbe(12)
	 if(yu.le.y1.and.y1.le.yo)
     +	 call strecke(0.,fy*(y1-yu),fx*(xo-xu),fy*(y1-yu))
	 call farbe(2)
	 if(yu.le.-y1.and.-y1.le.yo)
     +	 call strecke(0.,-fy*(y1+yu),fx*(xo-xu),-fy*(y1+yu))
	 if(inkey().eq.'x') stop
	 y1=10.*y1
	end do
	call textaus(4,' Geduld!'//cull())
	call farbe(15)
	r=ra
	x2=dlog(r)
	v=twert(r,90.d0)
	w=twert(r,0.d0)
	y2=(v-w)/max(v,w)
	do while(r.lt.re)
	 x1=x2
	 y1=y2
	 r=r*fak
	 x2=dlog(r)
	 v=twert(r,90.d0)
	 w=twert(r,0.d0)
	 y2=(v-w)/max(v,w)
	 if(y1.ge.yu.and.y2.ge.yu)
     +	 call strecke(fx*(x1-xu),fy*(y1-yu),fx*(x2-xu),fy*(y2-yu))
	end do
	call textaus(4,' weiter fenster? '//cull())
	if(inkey().eq.'f') then
	 dummy=getlkr (x1,y1)
	 x2=x1
	 do while(x1.eq.x2)
	 dummy=getlkr (x2,y2)
	 end do
	 ra=exp(xu+x1/fx)
	 re=exp(xu+x2/fx)
	 goto 1
	end if
	call endgrphc()
	end
	real*8 function twert(r,alpha)
	implicit none
	real*8 alpha,c,gc,m,r,s,ta,tn,dt,pi,xa(2),xn(2)
	real*8 v(2),vn(2),b(2),wa,wn,fak,eps,delta
	data fak/1.01/,eps/.00001/,delta/.0000001d0/
	data gc/6.67259D-11/,c/299792458.d0/,s/3.085678d17/,m/1.99d30/
*	Gravitationskonstante Lichtgeschwindigkeit Abstand Sonnenmasse
	pi=8.d0*datan(1.d0)
	xa(1)=r*dcos(alpha*pi/360.d0)
	xa(2)=r*dsin(alpha*pi/360.d0)	
	v(1)=0.
	v(2)=c
	dt=delta
	ta=0.
	wa=r
	do while(wa.lt.s)
	 tn=ta+dt
	 b(1)=-xa(1)*gc*m/wa**3
	 b(2)=-xa(2)*gc*m/wa**3
	 vn(1)=v(1)+dt*b(1)
	 vn(2)=v(2)+dt*b(2)
	 xn(1)=xa(1)+dt*vn(1)
	 xn(2)=xa(2)+dt*vn(2)
	 wn=dsqrt(xn(1)**2+xn(2)**2)
	 if(wn.lt.s) then
	  if(dsqrt(((vn(1)-v(1))**2+(vn(2)-v(2))**2)/
     +		(vn(1)**2+vn(2)**2)).lt.eps*.2d0) dt=dt*fak
	  xa(1)=xn(1)
	  xa(2)=xn(2)
	  v(1)=vn(1)
	  v(2)=vn(2)
	  ta=tn
	  wa=wn
	 else
	  twert=(ta*(wn-s)+tn*(s-wa))/(wn-wa)-s/c
	  return
	 end if
	end do
	end
